unit uInstaller;

interface

uses
  uHouse                        // for THouse, TWindow, TDoor
  ;

type

  TDoubleGlazingInstaller = class(THouseVisitor)
  private

  public

    procedure AllowVisitorToDoSomethingTo(House: THouse); override;
    procedure AllowVisitorToDoSomethingTo(Window: TWindow); override;
    procedure AllowVisitorToDoSomethingTo(Door: TDoor); override;

  end;

procedure InstallPlasticInHouse(House: THouse);

implementation

uses
  graphics                        // for clWhite
  ;

procedure InstallPlasticInHouse(House: THouse);
var
  Visitor: TDoubleGlazingInstaller;
begin
  Visitor := TDoubleGlazingInstaller.Create;
  try { ... finally }
    House.AcceptVisitFrom(Visitor);
  finally
    Visitor.Free;
  end;  { try ... finally }

end;

{ TDoubleGlazingInstaller }

procedure TDoubleGlazingInstaller.AllowVisitorToDoSomethingTo(
  Window: TWindow);
begin
  Window.Material := tmPlastic;
  Window.Colour := clWhite;
end;

procedure TDoubleGlazingInstaller.AllowVisitorToDoSomethingTo(
  House: THouse);
begin
  // Do nothing to a house
end;

procedure TDoubleGlazingInstaller.AllowVisitorToDoSomethingTo(Door: TDoor);
begin
  Door.Material := tmPlastic;
  Door.Colour := clWhite;
end;

end.
 